/[gentoo-x86]/eclass/kde4-meta.eclass
Gentoo

Diff of /eclass/kde4-meta.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.11 Revision 1.59
1# Copyright 1999-2009 Gentoo Foundation 1# Copyright 1999-2011 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/kde4-meta.eclass,v 1.11 2009/03/01 11:44:09 scarabeus Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/kde4-meta.eclass,v 1.59 2011/12/18 00:00:45 dilfridge Exp $
4# 4#
5# @ECLASS: kde4-meta.eclass 5# @ECLASS: kde4-meta.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# kde@gentoo.org 7# kde@gentoo.org
8# @BLURB: Eclass for writing "split" KDE packages. 8# @BLURB: Eclass for writing "split" KDE packages.
10# This eclass provides all necessary functions for writing split KDE ebuilds. 10# This eclass provides all necessary functions for writing split KDE ebuilds.
11# 11#
12# You must define KMNAME to use this eclass, and do so before inheriting it. All other variables are optional. 12# You must define KMNAME to use this eclass, and do so before inheriting it. All other variables are optional.
13# Do not include the same item in more than one of KMMODULE, KMMEXTRA, KMCOMPILEONLY, KMEXTRACTONLY. 13# Do not include the same item in more than one of KMMODULE, KMMEXTRA, KMCOMPILEONLY, KMEXTRACTONLY.
14 14
15[[ -z ${KMNAME} ]] && die "kde4-meta.eclass inherited but KMNAME not defined - broken ebuild"
16
15inherit kde4-base versionator 17inherit kde4-base versionator
16 18
17EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_test src_install pkg_postinst pkg_postrm 19KDEMETA_EXPF="pkg_setup src_unpack src_prepare src_configure src_compile src_test src_install pkg_preinst pkg_postinst pkg_postrm"
18 20EXPORT_FUNCTIONS ${KDEMETA_EXPF}
19if [[ -z ${KMNAME} ]]; then
20 die "kde4-meta.eclass inherited but KMNAME not defined - broken ebuild"
21fi
22
23case ${KDEBASE} in
24 kde-base)
25 HOMEPAGE="http://www.kde.org/"
26 LICENSE="GPL-2"
27 ;;
28 koffice)
29 HOMEPAGE="http://www.koffice.org/"
30 LICENSE="GPL-2"
31 ;;
32esac
33 21
34# Add dependencies that all packages in a certain module share. 22# Add dependencies that all packages in a certain module share.
35case ${KMNAME} in 23case ${KMNAME} in
36 kdebase|kdebase-workspace|kdebase-runtime) 24 kdebase|kdebase-apps|kde-baseapps|kdebase-workspace|kde-workspace|kdebase-runtime|kde-runtime|kdegraphics)
37 DEPEND="${DEPEND} >=kde-base/qimageblitz-0.0.4" 25 COMMONDEPEND+=" >=media-libs/qimageblitz-0.0.4"
38 RDEPEND="${RDEPEND} >=kde-base/qimageblitz-0.0.4"
39 ;; 26 ;;
40 kdepim) 27 kdepim|kdepim-runtime)
41 DEPEND="${DEPEND} dev-libs/boost app-office/akonadi-server"
42 RDEPEND="${RDEPEND} dev-libs/boost"
43 if [[ ${PN} != kode ]]; then
44 DEPEND="${DEPEND} >=kde-base/kode-${PV}:${SLOT}[kdeprefix=]"
45 RDEPEND="${RDEPEND} >=kde-base/kode-${PV}:${SLOT}[kdeprefix=]"
46 fi
47 case ${PN} in 28 case ${PN} in
48 akregator|kaddressbook|kjots|kmail|kmobiletools|knode|knotes|korganizer|ktimetracker) 29 akregator|kaddressbook|kjots|kmail|knode|knotes|korganizer|ktimetracker)
49 IUSE="+kontact" 30 IUSE+=" +kontact"
50 DEPEND="${DEPEND} kontact? ( >=kde-base/kontactinterfaces-${PV}:${SLOT}[kdeprefix=] )" 31 RDEPEND+=" kontact? ( $(add_kdebase_dep kontact) )"
51 RDEPEND="${RDEPEND} kontact? ( >=kde-base/kontactinterfaces-${PV}:${SLOT}[kdeprefix=] )"
52 ;; 32 ;;
53 esac 33 esac
54 ;; 34 ;;
55 kdegames) 35 kdegames)
56 if [[ ${PN} != libkdegames ]]; then 36 if [[ ${PN} != libkdegames ]]; then
57 DEPEND="${DEPEND} >=kde-base/libkdegames-${PV}:${SLOT}[kdeprefix=]" 37 COMMONDEPEND+=" $(add_kdebase_dep libkdegames)"
58 RDEPEND="${RDEPEND} >=kde-base/libkdegames-${PV}:${SLOT}[kdeprefix=]"
59 fi 38 fi
60 ;; 39 ;;
61 koffice) 40 koffice)
62 [[ ${PN} != koffice-data ]] && IUSE="debug" 41 [[ ${PN} != koffice-data ]] && IUSE+=" debug"
63 case ${PV} in 42 RDEPEND+="
64 9999*) DEPEND="${DEPEND} !app-office/${PN}:2" ;;
65 1.9*|2*) DEPEND="${DEPEND} !app-office/${PN}:live" ;;
66 esac
67 DEPEND="${DEPEND}
68 !app-office/${PN}:0 43 !app-office/${PN}:0
69 !app-office/koffice:0 44 !app-office/koffice:0
70 !app-office/koffice-meta:0" 45 !app-office/koffice-meta:0
71 case ${PN} in 46 "
72 koffice-data) 47 if has openexr ${IUSE//+}; then
73 DEPEND="${DEPEND} media-libs/lcms" 48 COMMONDEPEND+=" media-gfx/imagemagick[openexr?]"
74 RDEPEND="${RDEPEND} media-libs/lcms" 49 else
75 ;; 50 COMMONDEPEND+=" media-gfx/imagemagick"
76 *) 51 fi
77 DEPEND="${DEPEND} 52
53 COMMONDEPEND+="
78 dev-cpp/eigen:2 54 dev-cpp/eigen:2
79 media-gfx/imagemagick[openexr?]
80 media-libs/fontconfig 55 media-libs/fontconfig
81 media-libs/freetype:2 56 media-libs/freetype:2
82 " 57 "
83 RDEPEND="${DEPEND}"
84 if [[ ${PN} != koffice-libs && ${PN} != koffice-data ]]; then 58 if [[ ${PN} != koffice-libs && ${PN} != koffice-data ]]; then
85 DEPEND="${DEPEND} 59 COMMONDEPEND+=" >=app-office/koffice-libs-${PV}:${SLOT}"
86 >=app-office/koffice-libs-${PV}:${SLOT}[kdeprefix=]"
87 RDEPEND="${RDEPEND}
88 >=app-office/koffice-libs-${PV}:${SLOT}[kdeprefix=]"
89 fi 60 fi
90 ;;
91 esac
92 ;; 61 ;;
93esac 62esac
94 63
64DEPEND+=" ${COMMONDEPEND}"
65RDEPEND+=" ${COMMONDEPEND}"
66unset COMMONDEPEND
67
95debug-print "line ${LINENO} ${ECLASS}: DEPEND ${DEPEND} - after metapackage-specific dependencies" 68debug-print "line ${LINENO} ${ECLASS}: DEPEND ${DEPEND} - after metapackage-specific dependencies"
96debug-print "line ${LINENO} ${ECLASS}: RDEPEND ${RDEPEND} - after metapackage-specific dependencies" 69debug-print "line ${LINENO} ${ECLASS}: RDEPEND ${RDEPEND} - after metapackage-specific dependencies"
97 70
98# Useful to build kde4-meta style stuff from extragear/playground (plasmoids etc) 71# Useful to build kde4-meta style stuff from extragear/playground (plasmoids etc)
99case ${SLOT} in 72case ${BUILD_TYPE} in
100 live) 73 live)
74 if [[ ${KDE_SCM} == svn ]]; then
101 case ${KMNAME} in 75 case ${KMNAME} in
102 extragear*|playground*) 76 extragear*|playground*)
103 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}" 77 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}"
78 ESVN_PROJECT="${KMNAME}${ESVN_PROJECT_SUFFIX}"
104 ;; 79 ;;
105 esac 80 esac
81 fi
106 ;; 82 ;;
107esac 83esac
108 84
109# @ECLASS-VARIABLE: KMNAME 85# @ECLASS-VARIABLE: KMNAME
110# @DESCRIPTION: 86# @DESCRIPTION:
125# If set to "true", $KMMODULE doesn't have to be defined. 101# If set to "true", $KMMODULE doesn't have to be defined.
126# 102#
127# Example usage: If you're installing subdirectories of a package, like plugins, 103# Example usage: If you're installing subdirectories of a package, like plugins,
128# you mark the top subdirectory (containing the package) as $KMEXTRACTONLY, and 104# you mark the top subdirectory (containing the package) as $KMEXTRACTONLY, and
129# set KMNOMODULE="true". 105# set KMNOMODULE="true".
130if [[ -z ${KMMODULE} && ${KMNOMODULE} != true ]]; then 106if [[ -z ${KMMODULE} ]] && [[ ${KMNOMODULE} != true ]]; then
131 KMMODULE=${PN} 107 KMMODULE=${PN}
132fi 108fi
133 109
134# @ECLASS-VARIABLE: KMEXTRA 110# @ECLASS-VARIABLE: KMEXTRA
135# @DESCRIPTION: 111# @DESCRIPTION:
136# All subdirectories listed here will be extracted, compiled & installed. 112# All subdirectories listed here will be extracted, compiled & installed.
137# $KMMODULE is always added to $KMEXTRA. 113# $KMMODULE is always added to $KMEXTRA.
138# If the htmlhandbook USE-flag is set, and if this directory exists, 114# If KDE_HANDBOOK is 'always' or 'optional' and handbook USE-flag is set, and if this
139# then "doc/$KMMODULE" is added to $KMEXTRA. In other cases, this should be 115# directory exists, then "doc/$KMMODULE" is added to $KMEXTRA. If there's additional
140# handled in the ebuild.
141# If the documentation is in a different subdirectory, you should add it to KMEXTRA. 116# documentation in different subdirectories, it should be added to KMEXTRA manually..
142 117
143# @ECLASS-VARIABLE: KMCOMPILEONLY 118# @ECLASS-VARIABLE: KMCOMPILEONLY
144# @DESCRIPTION: 119# @DESCRIPTION:
145# All subdirectories listed here will be extracted & compiled, but not installed. 120# All subdirectories listed here will be extracted & compiled, but not installed.
146 121
155# Specify extra parameters to pass to tar, in kde4-meta_src_extract. 130# Specify extra parameters to pass to tar, in kde4-meta_src_extract.
156# '-xpf -j' are passed to tar by default. 131# '-xpf -j' are passed to tar by default.
157 132
158# @FUNCTION: kde4-meta_pkg_setup 133# @FUNCTION: kde4-meta_pkg_setup
159# @DESCRIPTION: 134# @DESCRIPTION:
160# Currently just calls its equivalent in kde4-base.eclass(5). Use this one in 135# Currently calls its equivalent in kde4-base.eclass(5) and checks the gcc version.
161# split ebuilds. 136# Use this one in split ebuilds.
162kde4-meta_pkg_setup() { 137kde4-meta_pkg_setup() {
163 debug-print-function ${FUNCNAME} "$@" 138 debug-print-function ${FUNCNAME} "$@"
164 139
165 kde4-base_pkg_setup 140 kde4-base_pkg_setup
166} 141}
167 142
168# @FUNCTION: kde4-meta_src_unpack 143# @FUNCTION: kde4-meta_src_unpack
169# @DESCRIPTION: 144# @DESCRIPTION:
170# This function unpacks the source for split ebuilds. See also 145# This function unpacks the source for split ebuilds.
171# kde4-meta-src_extract. 146# Further more is processed in kde4-meta_src_extract
172kde4-meta_src_unpack() { 147kde4-meta_src_unpack() {
173 debug-print-function ${FUNCNAME} "$@" 148 debug-print-function ${FUNCNAME} "$@"
174 149
175 if [[ ${BUILD_TYPE} = live ]]; then 150 if [[ ${BUILD_TYPE} = live ]]; then
151 case "${KDE_SCM}" in
152 svn)
176 migrate_store_dir 153 migrate_store_dir
177 S="${WORKDIR}/${P}" 154 S="${WORKDIR}/${P}"
178 mkdir -p "${S}" 155 mkdir -p "${S}"
179 ESVN_RESTRICT="export" subversion_src_unpack 156 ESVN_RESTRICT="export" subversion_src_unpack
180 subversion_wc_info 157 subversion_wc_info
181 subversion_bootstrap 158 subversion_bootstrap
159 ;;
160 git)
161 git-2_src_unpack
162 ;;
163 esac
164 fi
182 kde4-meta_src_extract 165 kde4-meta_src_extract
183 else
184 kde4-meta_src_extract
185 fi
186} 166}
187
188# FIXME: the difference between kde4-meta_src_extract and kde4-meta_src_unpack?
189 167
190# @FUNCTION: kde4-meta_src_extract 168# @FUNCTION: kde4-meta_src_extract
191# @DESCRIPTION: 169# @DESCRIPTION:
192# A function to unpack the source for a split KDE ebuild. 170# A function to extract the source for a split KDE ebuild.
193# Also see KMMODULE, KMNOMODULE, KMEXTRA, KMCOMPILEONLY, KMEXTRACTONLY and 171# Also see KMMODULE, KMNOMODULE, KMEXTRA, KMCOMPILEONLY, KMEXTRACTONLY and
194# KMTARPARAMS. 172# KMTARPARAMS.
195kde4-meta_src_extract() { 173kde4-meta_src_extract() {
196 debug-print-function ${FUNCNAME} "$@" 174 debug-print-function ${FUNCNAME} "$@"
197 175
198 if [[ ${BUILD_TYPE} = live ]]; then 176 if [[ ${BUILD_TYPE} = live ]]; then
199 local rsync_options subdir kmnamedir targetdir
200 # Export working copy to ${S} 177 # Export working copy to ${S}
201 einfo "Exporting parts of working copy to ${S}" 178 einfo "Exporting parts of working copy to ${S}"
202 kde4-meta_create_extractlists 179 kde4-meta_create_extractlists
203 180
181 case ${KDE_SCM} in
182 svn)
183 local rsync_options subdir targetdir wc_path escm
184
204 rsync_options="--group --links --owner --perms --quiet --exclude=.svn/" 185 rsync_options="--group --links --owner --perms --quiet --exclude=.svn/ --exclude=.git/"
186 wc_path="${ESVN_WC_PATH}"
187 escm="{ESVN}"
205 188
206 # Copy ${KMNAME} non-recursively (toplevel files) 189 # Copy ${KMNAME} non-recursively (toplevel files)
207 rsync ${rsync_options} "${ESVN_WC_PATH}"/${kmnamedir}* "${S}" \ 190 rsync ${rsync_options} "${wc_path}"/* "${S}" \
208 || die "${ESVN}: can't export toplevel files to '${S}'." 191 || die "${escm}: can't export toplevel files to '${S}'."
209 # Copy cmake directory 192 # Copy cmake directory
210 if [[ -d "${ESVN_WC_PATH}/${kmnamedir}cmake" ]]; then 193 if [[ -d "${wc_path}/cmake" ]]; then
211 rsync --recursive ${rsync_options} "${ESVN_WC_PATH}/${kmnamedir}cmake" "${S}" \ 194 rsync --recursive ${rsync_options} "${wc_path}/cmake" "${S}" \
212 || die "${ESVN}: can't export cmake files to '${S}'." 195 || die "${escm}: can't export cmake files to '${S}'."
213 fi
214 # Copy all subdirectories
215 for subdir in $(__list_needed_subdirectories); do
216 targetdir=""
217 if [[ $subdir = doc/* && ! -e "$ESVN_WC_PATH/$kmnamedir$subdir" ]]; then
218 continue
219 fi 196 fi
197 # Copy all subdirectories
198 for subdir in $(__list_needed_subdirectories); do
199 targetdir=""
200 if [[ $subdir = doc/* && ! -e "$wc_path/$subdir" ]]; then
201 continue
202 fi
220 203
221 [[ ${subdir%/} = */* ]] && targetdir=${subdir%/} && targetdir=${targetdir%/*} && mkdir -p "${S}/${targetdir}" 204 [[ ${subdir%/} = */* ]] && targetdir=${subdir%/} && targetdir=${targetdir%/*} && mkdir -p "${S}/${targetdir}"
222 rsync --recursive ${rsync_options} "${ESVN_WC_PATH}/${kmnamedir}${subdir%/}" "${S}/${targetdir}" \ 205 rsync --recursive ${rsync_options} "${wc_path}/${subdir%/}" "${S}/${targetdir}" \
223 || die "${ESVN}: can't export subdirectory '${subdir}' to '${S}/${targetdir}'." 206 || die "${escm}: can't export subdirectory '${subdir}' to '${S}/${targetdir}'."
224 done 207 done
225 208 ;;
226 if [[ ${KMNAME} = kdebase-runtime && ${PN} != kdebase-data ]]; then 209 esac
227 sed -i -e '/^install(PROGRAMS[[:space:]]*[^[:space:]]*\/kde4[[:space:]]/s/^/#DONOTINSTALL /' \
228 "${S}"/CMakeLists.txt || die "Sed to exclude bin/kde4 failed"
229 fi
230 else 210 else
231 local abort tarball tarfile f extractlist moduleprefix 211 local abort tarball tarfile f extractlist postfix
232 212
213 KMTARPARAMS+=" --bzip2"
214 postfix="bz2"
215
233 case $KMNAME in 216 case ${KMNAME} in
234 kdebase-apps) 217 kdebase-apps)
235 tarball="${KMNAME#-apps}-${PV}.tar.bz2" 218 # kdebase/apps -> kdebase-apps
219 tarball="kdebase-${PV}.tar.${postfix}"
236 ;; 220 ;;
237 *) 221 *)
222 # Create tarball name from module name (this is the default)
238 tarball="${KMNAME}-${PV}.tar.bz2" 223 tarball="${KMNAME}-${PV}.tar.${postfix}"
239 ;; 224 ;;
240 esac 225 esac
226
227 # Full path to source tarball
241 tarfile="${DISTDIR}/${tarball}" 228 tarfile="${DISTDIR}/${tarball}"
242 229
230 # Detect real toplevel dir from tarball name - it will be used upon extraction
231 # and in __list_needed_subdirectories
232 topdir="${tarball%.tar.*}/"
233
243 ebegin "Unpacking parts of ${tarball} to ${WORKDIR}" 234 ebegin "Unpacking parts of ${tarball} to ${WORKDIR}"
244 235
245 kde4-meta_create_extractlists 236 kde4-meta_create_extractlists
246 237
247 for f in cmake/ CMakeLists.txt ConfigureChecks.cmake config.h.cmake \ 238 for f in cmake/ CMakeLists.txt ConfigureChecks.cmake config.h.cmake
248 AUTHORS COPYING INSTALL README NEWS ChangeLog
249 do 239 do
250 extractlist="${extractlist} ${KMNAME}-${PV}/${f}" 240 extractlist+=" ${topdir}${f}"
251 done 241 done
252 extractlist="${extractlist} $(__list_needed_subdirectories)" 242 extractlist+=" $(__list_needed_subdirectories)"
253 KMTARPARAMS="${KMTARPARAMS} -j"
254 243
255 pushd "${WORKDIR}" > /dev/null 244 pushd "${WORKDIR}" > /dev/null
245
246 # @ECLASS-VARIABLE: KDE4_STRICTER
247 # @DESCRIPTION:
248 # Print out all issues found executing tar / kmextract files
249 # Set on if you want to find issues in kde-base ebuild unpack sequences
256 [[ -n ${KDE4_STRICTER} ]] && echo tar -xpf "${tarfile}" ${KMTARPARAMS} ${extractlist} >&2 250 [[ -n ${KDE4_STRICTER} ]] && echo 'tar -xpf "${tarfile}" ${KMTARPARAMS} ${extractlist}'
257 tar -xpf "${tarfile}" ${KMTARPARAMS} ${extractlist} 2> /dev/null 251 if [[ ${I_KNOW_WHAT_I_AM_DOING} ]]; then
252 # to make the devs happy - bug 338397
253 tar -xpf "${tarfile}" ${KMTARPARAMS} ${extractlist} || ewarn "tar extract command failed at least partially - continuing anyway"
254 else
255 tar -xpf "${tarfile}" ${KMTARPARAMS} ${extractlist} 2> /dev/null || echo "tar extract command failed at least partially - continuing anyway"
256 fi
258 257
259 # Default $S is based on $P; rename the extracted directory to match $S if necessary 258 # Default $S is based on $P; rename the extracted directory to match $S if necessary
259 if [[ ${KMNAME} != ${PN} ]]; then
260 mv ${KMNAME}-${PV} ${P} || die "Died while moving \"${KMNAME}-${PV}\" to \"${P}\"" 260 mv ${topdir} ${P} || die "Died while moving \"${topdir}\" to \"${P}\""
261 fi
261 262
262 popd > /dev/null 263 popd > /dev/null
263 264
264 eend $? 265 eend $?
265
266 # We need to clear it here to make verification below work
267 unset moduleprefix
268 266
269 if [[ -n ${KDE4_STRICTER} ]]; then 267 if [[ -n ${KDE4_STRICTER} ]]; then
270 for f in $(__list_needed_subdirectories fatal); do 268 for f in $(__list_needed_subdirectories fatal); do
271 if [[ ! -e "${S}/${f#*/}" ]]; then 269 if [[ ! -e ${S}/${f#*/} ]]; then
272 eerror "'${f#*/}' is missing" 270 eerror "'${f#*/}' is missing"
273 abort=true 271 abort=true
274 fi 272 fi
275 done 273 done
276 [[ -n ${abort} ]] && die "There were missing files." 274 [[ -n ${abort} ]] && die "There were missing files."
277 fi 275 fi
276
277 # We don't need it anymore
278 unset topdir
278 fi 279 fi
279} 280}
280 281
281# @FUNCTION: kde4-meta_create_extractlists 282# @FUNCTION: kde4-meta_create_extractlists
282# @DESCRIPTION: 283# @DESCRIPTION:
284# Also see descriptions of KMMODULE, KMNOMODULE, KMEXTRA, KMCOMPILEONLY, 285# Also see descriptions of KMMODULE, KMNOMODULE, KMEXTRA, KMCOMPILEONLY,
285# KMEXTRACTONLY and KMTARPARAMS. 286# KMEXTRACTONLY and KMTARPARAMS.
286kde4-meta_create_extractlists() { 287kde4-meta_create_extractlists() {
287 debug-print-function ${FUNCNAME} "$@" 288 debug-print-function ${FUNCNAME} "$@"
288 289
289 if has htmlhandbook ${IUSE//+} && use htmlhandbook; then 290 # Add default handbook locations
291 # FIXME - legacy code - remove when 4.4.5 is gone or preferrably port 4.4.5.
292 if [[ $(get_kde_version) < 4.5 ]] && use_if_iuse handbook && [[ -z ${KMNOMODULE} ]]; then
290 # We use the basename of $KMMODULE because $KMMODULE can contain 293 # We use the basename of $KMMODULE because $KMMODULE can contain
291 # the path to the module subdirectory. 294 # the path to the module subdirectory.
295 KMEXTRA_NONFATAL+="
296 doc/${KMMODULE##*/}"
297 fi
298
299 # Add default handbook locations
300 if [[ -z ${KMNOMODULE} ]] && ( [[ ${KDE_HANDBOOK} == always ]] || ( [[ ${KDE_HANDBOOK} == optional ]] && use handbook ) ); then
292 KMEXTRA_NONFATAL="${KMEXTRA_NONFATAL} doc/${KMMODULE##*/}" 301 KMEXTRA_NONFATAL+=" doc/${KMMODULE##*/}"
293 fi 302 fi
294 303
295 # Add some CMake-files to KMEXTRACTONLY. 304 # Add some CMake-files to KMEXTRACTONLY.
296 # Note that this actually doesn't include KMEXTRA handling. 305 # Note that this actually doesn't include KMEXTRA handling.
297 # In those cases you should care to add the relevant files to KMEXTRACTONLY 306 # In those cases you should care to add the relevant files to KMEXTRACTONLY
298 case ${KMNAME} in 307 case ${KMNAME} in
299 kdebase) 308 kdebase | kdebase-apps | kde-baseapps)
300 KMEXTRACTONLY="${KMEXTRACTONLY} 309 KMEXTRACTONLY+="
301 apps/config-apps.h.cmake
302 apps/ConfigureChecks.cmake"
303 ;;
304 kdebase-apps)
305 KMEXTRACTONLY="${KMEXTRACTONLY}
306 config-apps.h.cmake 310 config-apps.h.cmake
307 ConfigureChecks.cmake" 311 ConfigureChecks.cmake"
308 ;; 312 ;;
309 kdebase-runtime) 313 kdebase-runtime | kde-runtime)
310 KMEXTRACTONLY="${KMEXTRACTONLY} 314 KMEXTRACTONLY+="
311 config-runtime.h.cmake" 315 config-runtime.h.cmake"
312 ;; 316 ;;
313 kdebase-workspace) 317 kdebase-workspace | kde-workspace)
314 KMEXTRACTONLY="${KMEXTRACTONLY} 318 KMEXTRACTONLY+="
315 config-unix.h.cmake 319 config-unix.h.cmake
316 ConfigureChecks.cmake 320 ConfigureChecks.cmake
317 config-workspace.h.cmake 321 config-workspace.h.cmake
318 config-X11.h.cmake 322 config-X11.h.cmake
319 startkde.cmake 323 startkde.cmake
320 KDE4WorkspaceConfig.cmake.in" 324 KDE4WorkspaceConfig.cmake.in"
321 ;; 325 ;;
322 kdegames) 326 kdegames)
323 if [[ ${PN} != libkdegames ]]; then 327 if [[ ${PN} != libkdegames ]]; then
324 KMEXTRACTONLY="${KMEXTRACTONLY} 328 KMEXTRACTONLY+="
325 libkdegames" 329 libkdegames/"
330 KMLOADLIBS="${KMLOADLIBS} libkdegames"
326 fi 331 fi
327 ;; 332 ;;
328 kdepim) 333 kdepim)
329 KMEXTRACTONLY="${KMEXTRACTONLY} 334 if [[ ${PN} != libkdepim ]]; then
335 KMEXTRACTONLY+="
336 libkdepim/"
337 fi
338 KMEXTRACTONLY+="
339 config-enterprise.h.cmake
330 kleopatra/ConfigureChecks.cmake 340 kleopatra/ConfigureChecks.cmake"
331 libkdepim/kdepim_export.h" 341 if ! [[ $(get_kde_version) < 4.5 ]]; then
332 if has kontact ${IUSE//+} && use kontact; then 342 KMEXTRACTONLY+="
343 CTestCustom.cmake
344 kdepim-version.h.cmake"
345 else
346 KMEXTRACTONLY+="
347 kdepim-version.h"
348 fi
349 if use_if_iuse kontact; then
350 KMEXTRA+="
333 KMEXTRA="${KMEXTRA} kontact/plugins/${PLUGINNAME:-${PN}}" 351 kontact/plugins/${PLUGINNAME:-${PN}}/"
334 KMEXTRACTONLY="${KMEXTRACTONLY} kontactinterfaces/"
335 fi 352 fi
353 ;;
354 kdeutils)
355 KMEXTRACTONLY+="
356 kdeutils-version.h"
336 ;; 357 ;;
337 koffice) 358 koffice)
338 KMEXTRACTONLY="${KMEXTRACTONLY} 359 KMEXTRACTONLY+="
339 config-endian.h.cmake
340 filters/config-filters.h.cmake 360 filters/config-filters.h.cmake
361 "
362 case ${PV} in
363 2.[12].*)
364 KMEXTRACTONLY+="
341 config-openctl.h.cmake 365 config-endian.h.cmake
342 config-openexr.h.cmake 366 config-openexr.h.cmake
343 config-opengl.h.cmake 367 config-opengl.h.cmake
344 config-prefix.h.cmake" 368 config-prefix.h.cmake"
369 ;;
370 esac
345 ;; 371 ;;
346 esac 372 esac
347 # Don't install cmake modules for split ebuilds, to avoid collisions. 373 # Don't install cmake modules for split ebuilds, to avoid collisions.
374 # note: kdegraphics >= 4.6.2 does not even have code to do that, so we
375 # should not try in that case
376 # note2: kdeedu 4.6.4 does not have a cmake/modules/ subdir anymore :(
377 # it may be possible to formulate this shorter, but it should also
378 # still be understandable...
379 if [[ ${KMNAME} != kdegraphics || ( ( $(get_kde_version) != 4.6 || ${PV} < 4.6.2 ) && $(get_kde_version) < 4.7 ) ]] \
380 && ! [[ ${KMNAME} == kdeedu && ( ${PV} == 4.6.4 || ${PV} == 4.6.5 ) ]]; then
348 case ${KMNAME} in 381 case ${KMNAME} in
349 kdebase-runtime|kdebase-workspace|kdeedu|kdegames|kdegraphics|kdepim) 382 kdebase-runtime|kde-runtime|kdebase-workspace|kde-workspace|kdeedu|kdegames|kdegraphics)
350 case ${PN} in 383 case ${PN} in
351 libkdegames|libkdeedu|marble|libkworkspace) 384 libkdegames|libkdeedu|libkworkspace)
352 KMEXTRA="${KMEXTRA} 385 KMEXTRA+="
353 cmake/modules/" 386 cmake/modules/"
354 ;; 387 ;;
355 *) 388 *)
356 KMCOMPILEONLY="${KMCOMPILEONLY} 389 KMCOMPILEONLY+="
357 cmake/modules/" 390 cmake/modules/"
358 ;; 391 ;;
359 esac 392 esac
360 ;; 393 ;;
361 esac 394 esac
395 fi
362 396
363 debug-print "line ${LINENO} ${ECLASS} ${FUNCNAME}: KMEXTRACTONLY ${KMEXTRACTONLY}" 397 debug-print "line ${LINENO} ${ECLASS} ${FUNCNAME}: KMEXTRACTONLY ${KMEXTRACTONLY}"
364} 398}
365 399
366__list_needed_subdirectories() { 400__list_needed_subdirectories() {
367 local i j kmextra kmextra_expanded kmmodule_expanded kmcompileonly_expanded extractlist topdir 401 local i j kmextra kmextra_expanded kmmodule_expanded kmcompileonly_expanded extractlist
368 402
369 # We expand KMEXTRA by adding CMakeLists.txt files 403 # We expand KMEXTRA by adding CMakeLists.txt files
370 kmextra="${KMEXTRA}" 404 kmextra="${KMEXTRA}"
371 [[ ${1} != fatal ]] && kmextra="${kmextra} ${KMEXTRA_NONFATAL}" 405 [[ ${1} != fatal ]] && kmextra+=" ${KMEXTRA_NONFATAL}"
372 for i in ${kmextra}; do 406 for i in ${kmextra}; do
373 kmextra_expanded="${kmextra_expanded} ${i}" 407 kmextra_expanded+=" ${i}"
374 j=$(dirname ${i}) 408 j=$(dirname ${i})
375 while [[ ${j} != "." ]]; do 409 while [[ ${j} != "." ]]; do
376 kmextra_expanded="${kmextra_expanded} ${j}/CMakeLists.txt"; 410 kmextra_expanded+=" ${j}/CMakeLists.txt";
377 j=$(dirname ${j}) 411 j=$(dirname ${j})
378 done 412 done
379 done 413 done
380 414
381 # Expand KMMODULE 415 # Expand KMMODULE
382 if [[ -n ${KMMODULE} ]]; then 416 if [[ -n ${KMMODULE} ]]; then
383 kmmodule_expanded="${KMMODULE}" 417 kmmodule_expanded="${KMMODULE}"
384 j=$(dirname ${KMMODULE}) 418 j=$(dirname ${KMMODULE})
385 while [[ ${j} != "." ]]; do 419 while [[ ${j} != "." ]]; do
386 kmmodule_expanded="${kmmodule_expanded} ${j}/CMakeLists.txt"; 420 kmmodule_expanded+=" ${j}/CMakeLists.txt";
387 j=$(dirname ${j}) 421 j=$(dirname ${j})
388 done 422 done
389 fi 423 fi
390 424
391 # Expand KMCOMPILEONLY 425 # Expand KMCOMPILEONLY
392 for i in ${KMCOMPILEONLY}; do 426 for i in ${KMCOMPILEONLY}; do
393 kmcompileonly_expanded="${kmcompileonly_expanded} ${i}" 427 kmcompileonly_expanded+=" ${i}"
394 j=$(dirname ${i}) 428 j=$(dirname ${i})
395 while [[ ${j} != "." ]]; do 429 while [[ ${j} != "." ]]; do
396 kmcompileonly_expanded="${kmcompileonly_expanded} ${j}/CMakeLists.txt"; 430 kmcompileonly_expanded+=" ${j}/CMakeLists.txt";
397 j=$(dirname ${j}) 431 j=$(dirname ${j})
398 done 432 done
399 done 433 done
400 434
401 debug-print "line ${LINENO} ${ECLASS} ${FUNCNAME} - kmextra_expanded: ${kmextra_expanded}" 435 debug-print "line ${LINENO} ${ECLASS} ${FUNCNAME} - kmextra_expanded: ${kmextra_expanded}"
402 debug-print "line ${LINENO} ${ECLASS} ${FUNCNAME} - kmmodule_expanded: ${kmmodule_expanded}" 436 debug-print "line ${LINENO} ${ECLASS} ${FUNCNAME} - kmmodule_expanded: ${kmmodule_expanded}"
403 debug-print "line ${LINENO} ${ECLASS} ${FUNCNAME} - kmcompileonly_expanded: ${kmcompileonly_expanded}" 437 debug-print "line ${LINENO} ${ECLASS} ${FUNCNAME} - kmcompileonly_expanded: ${kmcompileonly_expanded}"
404 438
405 case ${PV} in
406 scm|9999*) : ;;
407 *) topdir="${KMNAME}-${PV}/" ;;
408 esac
409 # Create final list of stuff to extract 439 # Create final list of stuff to extract
410 # We append topleveldir only when specified (usually for tarballs) 440 # We append topdir only when specified (usually for tarballs)
411 for i in ${kmmodule_expanded} ${kmextra_expanded} ${kmcompileonly_expanded} \ 441 for i in ${kmmodule_expanded} ${kmextra_expanded} ${kmcompileonly_expanded} \
412 ${KMEXTRACTONLY} 442 ${KMEXTRACTONLY}
413 do 443 do
414 extractlist="${extractlist} ${topdir}${moduleprefix}${i}" 444 extractlist+=" ${topdir}${i}"
415 done 445 done
416 446
417 echo ${extractlist} 447 echo ${extractlist}
418} 448}
419 449
425 455
426 kde4-meta_change_cmakelists 456 kde4-meta_change_cmakelists
427 kde4-base_src_prepare 457 kde4-base_src_prepare
428} 458}
429 459
430 460# @FUNCTION: _change_cmakelists_parent_dirs
431# FIXME: no comment here? 461# @DESCRIPTION:
462# Adjust CMakeLists.txt to shadow subdirectories
463# that are not required for the build.
432_change_cmakelists_parent_dirs() { 464_change_cmakelists_parent_dirs() {
433 debug-print-function ${FUNCNAME} "$@" 465 debug-print-function ${FUNCNAME} "$@"
434 466
435 local _olddir _dir 467 local _olddir _dir
436 _dir="${S}"/${1} 468 _dir="${S}"/${1}
437 until [[ ${_dir} == "${S}" ]]; do 469 until [[ ${_dir} == ${S} ]]; do
438 _olddir=$(basename "${_dir}") 470 _olddir=$(basename "${_dir}")
439 _dir=$(dirname "${_dir}") 471 _dir=$(dirname "${_dir}")
440 debug-print "${LINENO}: processing ${_dir} CMakeLists.txt searching for ${_olddir}" 472 debug-print "${LINENO}: processing ${_dir} CMakeLists.txt searching for ${_olddir}"
441 if [[ -f ${_dir}/CMakeLists.txt ]]; then 473 if [[ -f ${_dir}/CMakeLists.txt ]]; then
442 sed -e "/add_subdirectory[[:space:]]*([[:space:]]*${_olddir}[[:space:]]*)/s/#DONOTCOMPILE //g" \ 474 sed -e "/add_subdirectory[[:space:]]*([[:space:]]*${_olddir}[[:space:]]*)/s/#DONOTCOMPILE //g" \
444 -i ${_dir}/CMakeLists.txt || die "${LINENO}: died in ${FUNCNAME} while processing ${_dir}" 476 -i ${_dir}/CMakeLists.txt || die "${LINENO}: died in ${FUNCNAME} while processing ${_dir}"
445 fi 477 fi
446 done 478 done
447} 479}
448 480
449# FIXME: add description
450# @FUNCTION: kde4-meta_change_cmakelists 481# @FUNCTION: kde4-meta_change_cmakelists
451# @DESCRIPTION: 482# @DESCRIPTION:
483# Adjust CMakeLists.txt to comply to our splitting.
452kde4-meta_change_cmakelists() { 484kde4-meta_change_cmakelists() {
453 debug-print-function ${FUNCNAME} "$@" 485 debug-print-function ${FUNCNAME} "$@"
454 486
455 pushd "${S}" > /dev/null 487 pushd "${S}" > /dev/null
456 488
457 comment_all_add_subdirectory ./ 489 comment_all_add_subdirectory ./
458 490
459 # Restore "add_subdirectory( cmake )" in ${S}/CMakeLists.txt 491 # Restore "add_subdirectory( cmake )" in ${S}/CMakeLists.txt
460 if [[ -f "${S}"/CMakeLists.txt ]]; then 492 if [[ -f CMakeLists.txt ]]; then
461 sed -e '/add_subdirectory[[:space:]]*([[:space:]]*cmake[[:space:]]*)/s/^#DONOTCOMPILE //' \ 493 sed -e '/add_subdirectory[[:space:]]*([[:space:]]*cmake[[:space:]]*)/s/^#DONOTCOMPILE //' \
462 -e '/ADD_SUBDIRECTORY[[:space:]]*([[:space:]]*cmake[[:space:]]*)/s/^#DONOTCOMPILE //' \ 494 -e '/ADD_SUBDIRECTORY[[:space:]]*([[:space:]]*cmake[[:space:]]*)/s/^#DONOTCOMPILE //' \
463 -i "${S}"/CMakeLists.txt || die "${LINENO}: cmake sed died" 495 -i CMakeLists.txt || die "${LINENO}: cmake sed died"
464 fi 496 fi
465 497
466 if [[ -z ${KMNOMODULE} ]]; then 498 if [[ -z ${KMNOMODULE} ]]; then
467 # Restore "add_subdirectory" in $KMMODULE subdirectories 499 # Restore "add_subdirectory" in $KMMODULE subdirectories
468 find "${S}"/${KMMODULE} -name CMakeLists.txt -print0 | xargs -0 sed -i -e 's/^#DONOTCOMPILE //g' || \ 500 find "${S}"/${KMMODULE} -name CMakeLists.txt -print0 | \
501 xargs -0 sed -i -e 's/^#DONOTCOMPILE //g' || \
469 die "${LINENO}: died in KMMODULE section" 502 die "${LINENO}: died in KMMODULE section"
470 _change_cmakelists_parent_dirs ${KMMODULE} 503 _change_cmakelists_parent_dirs ${KMMODULE}
471 fi 504 fi
472 505
506 local i
507
508 # KMEXTRACTONLY section - Some ebuilds need to comment out some subdirs in KMMODULE and they use KMEXTRACTONLY
509 for i in ${KMEXTRACTONLY}; do
510 if [[ -d ${i} && -f ${i}/../CMakeLists.txt ]]; then
511 sed -e "/([[:space:]]*$(basename $i)[[:space:]]*)/s/^/#DONOTCOMPILE /" \
512 -i ${i}/../CMakeLists.txt || \
513 die "${LINENO}: sed died while working in the KMEXTRACTONLY section while processing ${i}"
514 fi
515 done
516
473 # KMCOMPILEONLY 517 # KMCOMPILEONLY
474 local i
475 for i in ${KMCOMPILEONLY}; do 518 for i in ${KMCOMPILEONLY}; do
476 debug-print "${LINENO}: KMCOMPILEONLY, processing ${i}" 519 debug-print "${LINENO}: KMCOMPILEONLY, processing ${i}"
477 # Uncomment "add_subdirectory" instructions inside $KMCOMPILEONLY, then comment "install" instructions. 520 # Uncomment "add_subdirectory" instructions inside $KMCOMPILEONLY, then comment "install" instructions.
478 find "${S}"/${i} -name CMakeLists.txt -print0 | \ 521 find "${S}"/${i} -name CMakeLists.txt -print0 | \
479 xargs -0 sed -i \ 522 xargs -0 sed -i \
496 # KMEXTRA_NONFATAL section 539 # KMEXTRA_NONFATAL section
497 for i in ${KMEXTRA_NONFATAL}; do 540 for i in ${KMEXTRA_NONFATAL}; do
498 if [[ -d "${S}"/${i} ]]; then 541 if [[ -d "${S}"/${i} ]]; then
499 find "${S}"/${i} -name CMakeLists.txt -print0 | \ 542 find "${S}"/${i} -name CMakeLists.txt -print0 | \
500 xargs -0 sed -i -e 's/^#DONOTCOMPILE //g' || \ 543 xargs -0 sed -i -e 's/^#DONOTCOMPILE //g' || \
501 die "${LINENO}: sed died uncommenting add_subdirectory instructions in KMEXTRA section while processing ${i}" 544 die "${LINENO}: sed died uncommenting add_subdirectory instructions in KMEXTRA section while processing ${i}"
502 _change_cmakelists_parent_dirs ${i} 545 _change_cmakelists_parent_dirs ${i}
503 fi 546 fi
504 done 547 done
505 548
506 # KMEXTRACTONLY section - Some ebuilds need to comment out some subdirs in KMMODULE and they use KMEXTRACTONLY
507 for i in ${KMEXTRACTONLY}; do
508 if [[ -d "${S}"/${i} && -f "${S}"/${i}/../CMakeLists.txt ]]; then
509 sed -i -e "/([[:space:]]*$(basename $i)[[:space:]]*)/s/^/#DONOTCOMPILE /" "${S}"/${i}/../CMakeLists.txt || \
510 die "${LINENO}: sed died while working in the KMEXTRACTONLY section while processing ${i}"
511 fi
512 done
513
514 case ${KMNAME} in 549 case ${KMNAME} in
515 kdebase-workspace) 550 kdebase-workspace | kde-workspace)
516 # COLLISION PROTECT section 551 # COLLISION PROTECT section
517 # Install the startkde script just once, as a part of kde-base/kdebase-startkde, 552 # Install the startkde script just once, as a part of kde-base/kdebase-startkde,
518 # not as a part of every package. 553 # not as a part of every package.
519 if [[ ${PN} != kdebase-startkde && -f "${S}"/CMakeLists.txt ]]; then 554 if [[ ${PN} != kdebase-startkde && -f CMakeLists.txt ]]; then
520 # The startkde script moved to kdebase-workspace for KDE4 versions > 3.93.0. 555 # The startkde script moved to kdebase-workspace for KDE4 versions > 3.93.0.
521 sed -i -e '/startkde/s/^/#DONOTINSTALL /' "${S}"/CMakeLists.txt || \ 556 sed -e '/startkde/s/^/#DONOTINSTALL /' \
522 die "${LINENO}: sed died in the kdebase-startkde collision prevention section" 557 -i CMakeLists.txt || die "${LINENO}: sed died in the kdebase-startkde collision prevention section"
523 fi 558 fi
559 # Remove workspace target prefix in order to get direct linking to workspace libs
560 sed -e '/set(KDE4WORKSPACE_TARGET_PREFIX/s/^/#OVERRIDE /' \
561 -i CMakeLists.txt || die "${LINENO}: sed died in KDE4WORKSPACE_TARGET_PREFIX removal section"
524 # Strip EXPORT feature section from workspace for KDE4 versions > 4.1.82 562 # Strip EXPORT feature section from workspace for KDE4 versions > 4.1.82
525 if [[ ${PN} != libkworkspace ]]; then 563 if [[ ${PN} != libkworkspace ]]; then
526 sed -i -e '/install(FILES ${CMAKE_CURRENT_BINARY_DIR}\/KDE4WorkspaceConfig.cmake/,/^[[:space:]]*FILE KDE4WorkspaceLibraryTargets.cmake )[[:space:]]*^/d' \ 564 sed -e '/install(FILES ${CMAKE_CURRENT_BINARY_DIR}\/KDE4WorkspaceConfig.cmake/,/^[[:space:]]*FILE KDE4WorkspaceLibraryTargets.cmake )[[:space:]]*^/d' \
527 CMakeLists.txt || die "${LINENO}: sed died in kdebase-workspace strip EXPORT section" 565 -i CMakeLists.txt || die "${LINENO}: sed died in kde-workspace strip config install and fix EXPORT section"
528 fi 566 fi
567 if [[ ${PN} != plasma-workspace ]]; then
568 sed -e '/KActivities/s/REQUIRED//' \
569 -i CMakeLists.txt || die "${LINENO}: sed died in kde-workspace dep reduction section"
570 fi
529 ;; 571 ;;
530 kdebase-runtime) 572 kdebase-runtime | kde-runtime)
531 # COLLISION PROTECT section 573 # COLLISION PROTECT section
532 # Only install the kde4 script as part of kde-base/kdebase-data 574 # Only install the kde4 script as part of kde-base/kdebase-data
533 if [[ ${PN} != kdebase-data && -f "${S}"/CMakeLists.txt ]]; then 575 if [[ ${PN} != kdebase-data && -f CMakeLists.txt ]]; then
534 sed -i -e '/^install(PROGRAMS[[:space:]]*[^[:space:]]*\/kde4[[:space:]]/s/^/#DONOTINSTALL /' \ 576 sed -e '/^install(PROGRAMS[[:space:]]*[^[:space:]]*\/kde4[[:space:]]/s/^/#DONOTINSTALL /' \
535 "${S}"/CMakeLists.txt || die "Sed to exclude bin/kde4 failed" 577 -i CMakeLists.txt || die "Sed to exclude bin/kde4 failed"
536 fi 578 fi
579 ;;
580 kdenetwork)
581 # Disable hardcoded kdepimlibs check
582 sed -e 's/find_package(KdepimLibs REQUIRED)/macro_optional_find_package(KdepimLibs)/' \
583 -i CMakeLists.txt || die "failed to disable hardcoded checks"
537 ;; 584 ;;
538 kdepim) 585 kdepim)
586 # Disable hardcoded checks
587 sed -r -e '/find_package\(KdepimLibs/s/REQUIRED//' \
588 -e '/find_package\((KdepimLibs|Boost|QGpgme|Akonadi|ZLIB|Strigi|SharedDesktopOntologies|Soprano|Nepomuk)/{/macro_optional_/!s/find/macro_optional_&/}' \
589 -e '/macro_log_feature\((Boost|QGPGME|Akonadi|ZLIB|STRIGI|SHAREDDESKTOPONTOLOGIES|Soprano|Nepomuk)_FOUND/s/ TRUE / FALSE /' \
590 -e 's/if[[:space:]]*([[:space:]]*BUILD_.*)[[:space:]]*/if(1) # &/' \
591 -e 's/if[[:space:]]*([[:space:]]*[[:alnum:]]*_FOUND[[:space:]]*)[[:space:]]*$/if(1) # &/' \
592 -i CMakeLists.txt || die "failed to disable hardcoded checks"
593 # Disable broken or redundant build logic
594 if use_if_iuse kontact || [[ ${PN} = kontact ]]; then
595 sed -e 's/if[[:space:]]*([[:space:]]*BUILD_.*)[[:space:]]*$/if(1) # &/' \
596 -e 's/if[[:space:]]*([[:space:]]*[[:alnum:]]*_FOUND[[:space:]]*)[[:space:]]*$/if(1) # &/' \
597 -i kontact/plugins/CMakeLists.txt || die 'failed to override build logic'
598 fi
599 if [[ $(get_kde_version) < 4.5 ]]; then
539 case ${PN} in 600 case ${PN} in
540 kaddressbook|kalarm|kmailcvt|kontact|korganizer|korn) 601 kalarm|kmailcvt|kontact|korganizer|korn)
541 sed -i -n -e '/qt4_generate_dbus_interface(.*org\.kde\.kmail\.\(kmail\|mailcomposer\)\.xml/p' \ 602 sed -n -e '/qt4_generate_dbus_interface(.*org\.kde\.kmail\.\(kmail\|mailcomposer\)\.xml/p' \
542 -e '/add_custom_target(kmail_xml /,/)/p' "${S}"/kmail/CMakeLists.txt || die "uncommenting xml failed" 603 -e '/add_custom_target(kmail_xml /,/)/p' \
604 -i kmail/CMakeLists.txt || die "uncommenting xml failed"
543 _change_cmakelists_parent_dirs kmail 605 _change_cmakelists_parent_dirs kmail
544 ;; 606 ;;
545 esac 607 esac
608 fi
609 ;;
610 kdewebdev)
611 # Disable hardcoded checks
612 sed -e 's/find_package(KdepimLibs REQUIRED)/macro_optional_find_package(KdepimLibs)/' \
613 -e 's/find_package(LibXml2 REQUIRED)/macro_optional_find_package(LibXml2)/' \
614 -e 's/find_package(LibXslt REQUIRED)/macro_optional_find_package(LibXslt)/' \
615 -e 's/find_package(Boost REQUIRED)/macro_optional_find_package(Boost)/' \
616 -i CMakeLists.txt || die "failed to disable hardcoded checks"
546 ;; 617 ;;
547 koffice) 618 koffice)
548 # prevent collisions 619 # Prevent collisions
549 if [[ ${PN} != koffice-data ]]; then 620 if [[ ${PN} != koffice-data ]]; then
550 sed -i -e '/install(.*FindKOfficeLibs.cmake/,/)/ d' \ 621 sed -e '/install(.*FindKOfficeLibs.cmake/,/)/ d' \
551 "${S}"/cmake/modules/CMakeLists.txt || \ 622 -i cmake/modules/CMakeLists.txt || die "${LINENO}: sed died in collision prevention section"
623 sed -e '/install(.\+config-openexr\.h.\+)/d' \
552 die "${LINENO}: sed died in collision prevention section" 624 -i CMakeLists.txt || die "${LINENO}: sed died in collision prevention section"
553 sed -i -n -e '1h;1!H;${g;s/install(.\+config-openexr.h.\+)//;p}' \
554 "${S}"/CMakeLists.txt || \
555 die "${LINENO}: sed died in collision prevention section"
556 fi 625 fi
557 esac 626 esac
558 627
559 popd > /dev/null 628 popd > /dev/null
560} 629}
564# Currently just calls its equivalent in kde4-base.eclass(5). Use this one in split 633# Currently just calls its equivalent in kde4-base.eclass(5). Use this one in split
565# ebuilds. 634# ebuilds.
566kde4-meta_src_configure() { 635kde4-meta_src_configure() {
567 debug-print-function ${FUNCNAME} "$@" 636 debug-print-function ${FUNCNAME} "$@"
568 637
638 # backwards-compatibility: make mycmakeargs an array, if it isn't already
639 if [[ $(declare -p mycmakeargs 2>&-) != "declare -a mycmakeargs="* ]]; then
640 mycmakeargs=(${mycmakeargs})
641 fi
642
643 # Set some cmake default values here (usually workarounds for automagic deps)
644 case ${KMNAME} in
645 kdewebdev)
646 mycmakeargs=(
647 -DWITH_KdepimLibs=OFF
648 -DWITH_LibXml2=OFF
649 -DWITH_LibXslt=OFF
650 -DWITH_Boost=OFF
651 -DWITH_LibTidy=OFF
652 "${mycmakeargs[@]}"
653 )
654 ;;
655 esac
656
569 kde4-base_src_configure 657 kde4-base_src_configure
570} 658}
571 659
572# @FUNCTION: kde4-meta_src_compile 660# @FUNCTION: kde4-meta_src_compile
573# @DESCRIPTION: 661# @DESCRIPTION:
574# General function for compiling split KDE4 applications. 662# General function for compiling split KDE4 applications.
575# Overrides kde4-base_src_compile. 663# Overrides kde4-base_src_compile.
576kde4-meta_src_compile() { 664kde4-meta_src_compile() {
577 debug-print-function ${FUNCNAME} "$@" 665 debug-print-function ${FUNCNAME} "$@"
578 666
579 kde4-base_src_make 667 kde4-base_src_compile "$@"
580} 668}
581 669
582# @FUNCTION: kde4-meta_src_test 670# @FUNCTION: kde4-meta_src_test
583# @DESCRIPTION: 671# @DESCRIPTION:
584# Currently just calls its equivalent in kde4-base.eclass(5). Use this in split 672# Currently just calls its equivalent in kde4-base.eclass(5) if
585# ebuilds. 673# I_KNOW_WHAT_I_AM_DOING is set. Use this in split ebuilds.
586kde4-meta_src_test() { 674kde4-meta_src_test() {
587 debug-print-function $FUNCNAME "$@" 675 debug-print-function $FUNCNAME "$@"
588 676
677 if [[ $I_KNOW_WHAT_I_AM_DOING ]]; then
589 kde4-base_src_test 678 kde4-base_src_test
679 else
680 einfo "Tests disabled"
681 fi
590} 682}
591 683
592# @FUNCTION: kde4-meta_src_install 684# @FUNCTION: kde4-meta_src_install
593# @DESCRIPTION: 685# @DESCRIPTION:
594# Function for installing KDE4 split applications. 686# Function for installing KDE4 split applications.
595kde4-meta_src_install() { 687kde4-meta_src_install() {
596 debug-print-function $FUNCNAME "$@" 688 debug-print-function $FUNCNAME "$@"
597 689
598 kde4-meta_src_make_doc 690 # Search ${S}/${KMMODULE} and install common documentation files found
599 cmake-utils_src_install
600
601 if [[ -n ${KMSAVELIBS} ]]; then
602 install_library_dependencies
603 fi
604}
605
606# @FUNCTION: kde4-meta_src_make_doc
607# @DESCRIPTION:
608# This function searches in ${S}/${KMMODULE},
609# and tries to install "AUTHORS ChangeLog* README* NEWS todo" if these files exist.
610kde4-meta_src_make_doc() {
611 debug-print-function ${FUNCNAME} "$@"
612
613 local doc 691 local doc
614 for doc in AUTHORS ChangeLog* README* NEWS TODO; do 692 for doc in "${S}/${KMMODULE}"/{AUTHORS,CHANGELOG,ChangeLog*,README*,NEWS,TODO,HACKING}; do
615 [[ -s ${KMMODULE}/${doc} ]] && newdoc "${KMMODULE}/${doc}" "${doc}.${KMMODULE##*/}" 693 [[ -f "${doc}" ]] && [[ -s "${doc}" ]] && dodoc "${doc}"
616 done 694 done
617 695
618 kde4-base_src_make_doc 696 kde4-base_src_install
697}
698
699# @FUNCTION: kde4-meta_pkg_preinst
700# @DESCRIPTION:
701# Invoke its equivalent in kde4-base.eclass.
702kde4-meta_pkg_preinst() {
703 debug-print-function ${FUNCNAME} "$@"
704
705 kde4-base_pkg_preinst
619} 706}
620 707
621# @FUNCTION: kde4-meta_pkg_postinst 708# @FUNCTION: kde4-meta_pkg_postinst
622# @DESCRIPTION: 709# @DESCRIPTION:
623# Currently just calls its equivalent in kde4-base.eclass(5). Use this in split 710# Invoke kbuildsycoca4.
624# ebuilds.
625kde4-meta_pkg_postinst() { 711kde4-meta_pkg_postinst() {
626 debug-print-function ${FUNCNAME} "$@" 712 debug-print-function ${FUNCNAME} "$@"
627 713
628 kde4-base_pkg_postinst 714 kde4-base_pkg_postinst
629} 715}

Legend:
Removed from v.1.11  
changed lines
  Added in v.1.59

  ViewVC Help
Powered by ViewVC 1.1.20